; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

; 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\DIALOGS.INC
      include \masm32\macros\macros.asm
      include \masm32\include\ws2_32.inc

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\ws2_32.lib

      DialogProc    PROTO :DWORD,:DWORD,:DWORD,:DWORD
      CaptchaThread PROTO :DWORD

      BUFFER_SIZE equ 50000
      MAX_THREADS equ 45
      WM_TCLEANUP equ WM_APP+1


.data
WSAStruct WSADATA <>

SockErr db "  ",0
CapchaInit db "  anti-captcha",0
ErrOpen db "  ",0
TooLarge db "  ",0
noKey db "  ",0
MutexErr db "   ",0
MaxThreads db "   ",0
GetHostFail db "   IP-.        ",0
MemErr db "   ",0
Caption db "",0
BadKey db "  ",0


fRead dd 0




contentType db "image/jpeg",0
extension db "jpg",0
max_len dd 15
min_len dd 2

bAllocated db 0
ThreadCount dd 1
Threads dd 1




lineend db 13,10,0
text1 db "Got ID: ",0
text2 db "...",13,10,0

msg2 db "ERR %u",0
msg3 db "THR%u: ",0
msg4 db " %u",0

.data?
apikey db 50 dup(?)
iFile dd ?
FileSize dd ?
myFile dd 50 dup(?)

hWnd dd ?
hInstance dd ?
ThreadId dd 50 dup(?)

ImageSize dd 50 dup(?)

btnname db 30 dup(?)

hMutex dd ?
hMutex2 dd ?


is_numeric dd ?
is_regsense dd ?
is_phrase dd ?

.code

start:

mov hInstance, FUNC(GetModuleHandle,NULL)
call main
invoke ExitProcess,eax

main PROC
      invoke WSAStartup,0101h,offset WSAStruct
      test eax,eax
      je @F
      mov eax,offset SockErr
      jmp ErrBlock
    @@:

      mov ecx,MAX_THREADS

ALLOC:
      push ecx
      invoke VirtualAlloc,0,BUFFER_SIZE,MEM_COMMIT,PAGE_READWRITE
      pop ecx
      test eax,eax
      jne goodmem

      mov ebx,MAX_THREADS
      cmp ebx,ecx
      je next1

    freemem:
      push ebx
      push ecx
      invoke VirtualFree,myFile[ebx*4],0,MEM_RELEASE
      pop ecx
      pop ebx
      dec ebx
      cmp ebx,ecx
      jne freemem

    next1:
      mov eax,offset MemErr
      jmp ErrBlock
    goodmem:

      mov myFile[ecx*4],eax

loop ALLOC




      mov bAllocated,1

      call AntiCaptchaInit
      test eax,eax
      je @F
      mov eax,offset CapchaInit
      jmp ErrBlock
    @@:

      mov hMutex,FUNC(CreateMutex,NULL,FALSE,NULL)
      test eax,eax
      jne @F
      mov eax,offset MutexErr
      jmp ErrBlock
    @@:


      mov hMutex2,FUNC(CreateMutex,NULL,FALSE,NULL)
      test eax,eax
      jne @F
      invoke CloseHandle,hMutex
      mov eax,offset MutexErr
      jmp ErrBlock
    @@:


      Dialog " test (c) dx", \
             "MS Sans Serif",8, \
              WS_OVERLAPPED or \
              WS_SYSMENU or DS_CENTER, \
              9, \
              50,50,230,125, \
              1024

      DlgButton " 1",WS_TABSTOP,5,5,60,13,200
      DlgButton "",WS_TABSTOP+WS_DISABLED,5,20,60,13,201
      DlgEdit ES_READONLY+ES_MULTILINE+WS_BORDER+WS_TABSTOP+ES_AUTOVSCROLL+WS_VSCROLL,70,5,150,45,101
      DlgStatic ": ",0,5,55,28,12,102
      DlgEdit WS_BORDER+WS_TABSTOP,30,53,190,12,103
      DlgButton "",WS_TABSTOP,5,35,60,13,202

      DlgCheck "    ",WS_TABSTOP,5,70,135,12,90
      DlgCheck "   ",WS_TABSTOP,5,82,125,12,91
      DlgCheck "   ",WS_TABSTOP,5,94,125,12,92


      CallModalDialog hInstance,0,DialogProc,NULL


ret
ErrBlock:
  push eax
  .if bAllocated==1
      mov ecx,MAX_THREADS
FREEALLOC:
      push ecx
      invoke VirtualFree,myFile[ecx*4],0,MEM_RELEASE
      pop ecx
loop FREEALLOC

  .endif
  pop eax

  invoke MessageBox,0,eax,offset Caption,0
  invoke ExitProcess,0

ret
main ENDP








DialogProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
    LOCAL path  :DWORD
    LOCAL fname :DWORD
    LOCAL ThreadNum :DWORD


    .if uMsg == WM_INITDIALOG
      invoke SendMessage,hWin,WM_SETICON,1,
                         FUNC(LoadIcon,NULL,IDI_ASTERISK)
      m2m hWnd, hWin

      invoke SendDlgItemMessage,hWin,103,EM_SETLIMITTEXT,35,0
      invoke SendDlgItemMessage,hWin,91,BM_SETCHECK,BST_CHECKED,0


    .elseif uMsg == WM_COMMAND
      .if wParam==202
        jmp quit_dialog

      .elseif wParam==200
        .if ThreadCount==MAX_THREADS
          mov eax,offset MaxThreads
          jmp ErrBlock
        .endif

        mov path,chr$(" bmp, jpeg, gif, png",0,"*.bmp;*.gif;*.jpeg;*.jpg;*.jpe;*.png",0,0)
        mov fname,OpenFileDlg(hWnd,hInstance," ",path)
        cmp BYTE PTR [eax], 0
        jne @F
        xor eax,eax
        ret
      @@:

        mov iFile,FUNC(CreateFile,fname,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,NULL,NULL)
        cmp iFile,INVALID_HANDLE_VALUE
        jne @F
        mov eax,offset ErrOpen
        jmp ErrBlock
      @@:


        mov FileSize,FUNC(GetFileSize,iFile,NULL)
        cmp eax,BUFFER_SIZE
        jb @F
        invoke CloseHandle,iFile
        mov eax,offset TooLarge
        jmp ErrBlock
      @@:


        mov ecx,ThreadCount
        m2m ImageSize[ecx*4],FileSize

        mov fRead,0
        invoke ReadFile,iFile,myFile[ecx*4],eax,offset fRead,NULL

        invoke CloseHandle,iFile


        inc ThreadCount
        invoke wsprintf,offset btnname,offset msg4,ThreadCount
        invoke SetDlgItemText,hWin,200,offset btnname
        invoke GetDlgItem,hWnd,201
        invoke EnableWindow,eax,TRUE
      .elseif wParam==201
        invoke GetDlgItemText,hWin,103,offset apikey,45
        test eax,eax
        jne @F
        mov eax,offset noKey
        jmp ErrBlock
      @@:

        mov edi,offset apikey
      keycheck:
        mov al,byte ptr [edi]
        .if (al<'0' || al>'9') && (al<'a' || al>'f')
        mov eax,offset BadKey
        jmp ErrBlock
        .endif
        inc edi
        cmp byte ptr [edi],0
      jne keycheck

        invoke IsDlgButtonChecked,hWnd,90
        mov is_numeric,0
        .if eax==BST_CHECKED
          mov is_numeric,1
        .endif

        invoke IsDlgButtonChecked,hWnd,91
        mov is_regsense,0
        .if eax==BST_CHECKED
          mov is_regsense,1
        .endif

        invoke IsDlgButtonChecked,hWnd,92
        mov is_phrase,0
        .if eax==BST_CHECKED
          mov is_phrase,1
        .endif


        invoke GetDlgItem,hWnd,200
        invoke EnableWindow,eax,FALSE
        invoke GetDlgItem,hWnd,201
        invoke EnableWindow,eax,FALSE
        invoke SetDlgItemText,hWnd,101,offset text2

        m2m Threads,ThreadCount


        mov ecx,1
      Launch:
        mov ThreadNum,ecx
        push ecx
        invoke CreateThread,0,0,addr CaptchaThread,ThreadNum,0,NULL
        pop ecx
        mov ThreadId[ecx*4],eax

        inc ecx
        cmp ecx,ThreadCount
      jne Launch

      .endif

    ret
    .elseif uMsg == WM_CLOSE
      quit_dialog:
      call WSACleanup

      mov ecx,MAX_THREADS
FREEALLOC:
      push ecx
      invoke VirtualFree,myFile[ecx*4],0,MEM_RELEASE
      pop ecx
loop FREEALLOC

      .if Threads!=1
        mov ecx,1
      cleanupthr2:
        push ecx
        invoke CloseHandle,ThreadId[ecx*4]
        pop ecx
        inc ecx
        cmp ecx,Threads
      jne cleanupthr2
      .endif

      invoke CloseHandle,hMutex
      invoke CloseHandle,hMutex2
      invoke EndDialog,hWin,0

    .elseif uMsg==WM_TCLEANUP
        mov ecx,1
      cleanupthr:
        push ecx
        invoke CloseHandle,ThreadId[ecx*4]
        pop ecx
        inc ecx
        cmp ecx,Threads
      jne cleanupthr

      mov Threads,1
    .endif
xor eax,eax
ret
  ErrBlock:
    invoke MessageBox,hWnd,eax,offset Caption,0
    xor eax,eax
ret
DialogProc ENDP






CaptchaThread PROC ThreadNum:DWORD
        LOCAL cID [30] :BYTE
        LOCAL cANS [30] :BYTE
        LOCAL errnum [50] :BYTE


        mov eax,ThreadNum
        push myFile[eax*4]
        push ImageSize[eax*4]

        push offset contentType
        push offset extension
        push max_len
        push min_len
        push is_numeric
        push is_regsense
        push is_phrase
        push offset apikey
        lea eax,cID
        push eax
        call AntiCaptcha




        push ebx
        .if ebx!=0
          invoke wsprintf,addr errnum,offset msg2,ebx
        .else
          invoke lstrcpy,addr errnum,offset text1
          .if eax!=0
            lea ecx,cID
            invoke lstrcat,eax,ecx
          .endif
        .endif



        push ThreadNum
        lea eax,errnum
        push eax
        call AddText

        pop ebx

        .if ebx!=0
          call GetCaptchaError
          push ThreadNum
          push ebx
          call AddText

          invoke WaitForSingleObject,hMutex2,INFINITE
          cmp eax,WAIT_OBJECT_0
          je @F
          ret
        @@:

          dec ThreadCount
          cmp ThreadCount,1
          jne @F

          invoke GetDlgItem,hWnd,200
          invoke EnableWindow,eax,TRUE
          invoke SetDlgItemText,hWnd,200,chr$(" 1")
          invoke SendMessage,hWnd,WM_TCLEANUP,0,0
        @@:

          invoke ReleaseMutex,hMutex2
          ret
        .endif

        push ThreadNum
        push chr$("...")
        call AddText

        get_answer:
          push offset apikey
          lea eax,cID
          push eax
          lea eax,cANS
          push eax
          call AntiCaptchaAnswer

          test ebx,ebx
        je @F
          call GetCaptchaError
          push ThreadNum
          push ebx
          call AddText

          invoke Sleep,1000
          jmp get_answer
        @@:

        invoke lstrcpy,addr errnum,chr$(": ")
        .if eax!=0
          lea ecx,cANS
          invoke lstrcat,eax,ecx
        .endif

        push ThreadNum
        lea eax,errnum
        push eax
        call AddText


        invoke WaitForSingleObject,hMutex2,INFINITE
        cmp eax,WAIT_OBJECT_0
        je @F
        ret
      @@:

        dec ThreadCount
        cmp ThreadCount,1
        jne @F

        invoke GetDlgItem,hWnd,200
        invoke EnableWindow,eax,TRUE
        invoke SetDlgItemText,hWnd,200,chr$(" 1")
        invoke SendMessage,hWnd,WM_TCLEANUP,0,0
      @@:

        invoke ReleaseMutex,hMutex2

ret
CaptchaThread ENDP


GetCaptchaError PROC
  cmp ebx,1
  jne @F
  mov ebx,chr$("   ")
@@:

  cmp ebx,2
  jne @F
  mov ebx,chr$("  ")
@@:

  cmp ebx,4
  jne @F
  mov ebx,chr$("   ")
@@:

  cmp ebx,5
  jne @F
  mov ebx,chr$("   ")
@@:

  cmp ebx,6
  jne @F
  mov ebx,chr$("   ")
@@:

  cmp ebx,7
  jne @F
  mov ebx,chr$("  ")
@@:

  cmp ebx,10
  jne @F
  mov ebx,chr$("   ")
@@:

  cmp ebx,11
  jne @F
  mov ebx,chr$(" ")
@@:

  cmp ebx,13
  jne @F
  mov ebx,chr$("  ")
@@:

  cmp ebx,14
  jne @F
  mov ebx,chr$(" ID ")
@@:

  cmp ebx,12
  jne @F
  mov ebx,chr$("   ")
@@:

  cmp ebx,20
  jne @F
  mov ebx,chr$(" ")
@@:

ret
GetCaptchaError ENDP






AddText PROC, text:DWORD, tnum:DWORD
        LOCAL tmptxt [20] :BYTE



        invoke WaitForSingleObject,hMutex,INFINITE
        cmp eax,WAIT_OBJECT_0
        je @F
        ret
      @@:

        invoke wsprintf,addr tmptxt,offset msg3,tnum



        mov ebx,tnum
        invoke GetDlgItemText,hWnd,101,myFile[ebx*4],BUFFER_SIZE-50
        mov ebx,tnum



        add eax,myFile[ebx*4]

        lea ecx,tmptxt
        invoke lstrcat,eax,ecx

        .if eax!=0
          invoke lstrcat,eax,text
        .endif
        .if eax!=0
          invoke lstrcat,eax,offset lineend
        .endif

        mov ebx,tnum
        invoke SetDlgItemText,hWnd,101,myFile[ebx*4]
        invoke SendDlgItemMessage,hWnd,101,EM_LINESCROLL,0,10000

        invoke ReleaseMutex,hMutex
ret
AddText ENDP






;:
;push strN
;push strN-1
;...
;push str1
;push N-1
;push memory address

ConcatStrings PROC
        pop edi
        pop ebx
        pop ecx
        pop edx

        push ecx
        invoke lstrcpy,ebx,edx
        pop ecx

        concatx:
          pop edx
          push ecx
          .if eax!=0
            invoke lstrcat,eax,edx
          .endif
          pop ecx
        loop concatx

        push edi
ret
ConcatStrings ENDP



;  :
;push ____ - dword
;push _ - dword
;push content-type - string ptr
;push extension - string ptr
;push max_len - dword
;push min_len - dword
;push is_numeric - dword
;push is_regsense - dword
;push is_phrase - dword
;push apikey - string ptr
;push cID - string ptr
;
;       0  



AntiCaptcha PROC, AC_cID:DWORD, AC_apikey:DWORD, AC_is_phrase:DWORD, AC_is_regsense:DWORD, AC_is_numeric:DWORD, AC_min_len:DWORD, AC_max_len:DWORD, AC_extension:DWORD, AC_contentType:DWORD, AC_imageSize:DWORD, AC_imagePtr:DWORD
    AC_BUFFER_SIZE equ 2048

    LOCAL AC_bConnected:BYTE
    LOCAL AC_iSock:DWORD

    LOCAL AC_max_len_str [5] :BYTE
    LOCAL AC_min_len_str [5] :BYTE
    LOCAL AC_is_numeric_str [5] :BYTE
    LOCAL AC_is_regsense_str [5] :BYTE
    LOCAL AC_is_phrase_str [5] :BYTE


    LOCAL AC_DataLen:DWORD
    LOCAL AC_Data1Len:DWORD
    LOCAL AC_mem:DWORD
    LOCAL AC_Header [512] :BYTE
    LOCAL AC_Data1 [AC_BUFFER_SIZE] :BYTE

    LOCAL AC_querylen [10] :BYTE

    AC_boundary equ "---------FGf4Fh3fdjGQ148fdh"

  .data
    AC_SocketAddress sockaddr_in <>

    AC_content1 db '--',AC_boundary,13,10,'Content-Disposition: form-data; name="method"',13,10,13,10, \
                   'post',13,10,'--',AC_boundary,13,10, \
                   'Content-Disposition: form-data; name="key"',13,10,13,10,0
    AC_content2 db 13,10,'--',AC_boundary,13,10, \
                   'Content-Disposition: form-data; name="phrase"',13,10,13,10,0
    AC_content3 db 13,10,'--',AC_boundary,13,10, \
                   'Content-Disposition: form-data; name="regsense"',13,10,13,10,0
    AC_content4 db 13,10,'--',AC_boundary,13,10, \
                   'Content-Disposition: form-data; name="numeric"',13,10,13,10,0
    AC_content5 db 13,10,'--',AC_boundary,13,10, \
                   'Content-Disposition: form-data; name="min_len"',13,10,13,10,0
    AC_content6 db 13,10,'--',AC_boundary,13,10, \
                   'Content-Disposition: form-data; name="max_len"',13,10,13,10,0
    AC_content7 db 13,10,'--',AC_boundary,13,10, \
                   'Content-Disposition: form-data; name="file"; filename="capcha.',0
    AC_content8 db '"',13,10,'Content-Type: ',0
    AC_content9 db 13,10,13,10,0
    AC_content10 db 13,10,'--',AC_boundary,'--',0
    AC_content10len=($-AC_content10)
    AC_poststr1 db "POST /in.php HTTP/1.0",13,10, \
                   "Content-Type: multipart/form-data; boundary=",AC_boundary,13,10, \
                   "Host: www.anti-captcha.com",13,10, \
                   "Content-Length: ",0
    AC_poststr2 db 13,10,13,10,0

    AC_msg1 db "%u",0
    AC_substr1 db "OK|",0



  .code
    mov AC_bConnected,0

    lea eax,AC_Data1
    mov AC_mem,eax

    invoke socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
    CMP EAX,INVALID_SOCKET
    jne @F
    mov ebx,2
    jmp AC_CaptchaErr
  @@:

    mov AC_iSock,eax

    invoke connect,AC_iSock,offset AC_SocketAddress,sizeof AC_SocketAddress
    test eax,eax
    je @F
    mov ebx,3
    jmp AC_CaptchaErr
  @@:

    mov AC_bConnected,1


    push offset AC_content9
    push AC_contentType
    push offset AC_content8
    push AC_extension
    push offset AC_content7
    invoke wsprintf,addr AC_max_len_str,offset AC_msg1,AC_max_len
    lea eax, AC_max_len_str
    push eax
    push offset AC_content6
    invoke wsprintf,addr AC_min_len_str,offset AC_msg1,AC_min_len
    lea eax, AC_min_len_str
    push eax
    push offset AC_content5
    invoke wsprintf,addr AC_is_numeric_str,offset AC_msg1,AC_is_numeric
    lea eax, AC_is_numeric_str
    push eax
    push offset AC_content4
    invoke wsprintf,addr AC_is_regsense_str,offset AC_msg1,AC_is_regsense
    lea eax, AC_is_regsense_str
    push eax
    push offset AC_content3
    invoke wsprintf,addr AC_is_phrase_str,offset AC_msg1,AC_is_phrase
    lea eax, AC_is_phrase_str
    push eax
    push offset AC_content2
    push AC_apikey
    push offset AC_content1
    push 16
    lea eax,AC_Data1
    push eax

    call ConcatStrings
    test eax,eax
    jne @F
    mov ebx,4
    jmp AC_CaptchaErr
  @@:


    mov AC_DataLen,FUNC(lstrlen,addr AC_Data1)
    mov AC_Data1Len,eax
    mov eax,AC_imageSize
    add AC_DataLen,eax
    add AC_DataLen,AC_content10len
    invoke wsprintf,addr AC_querylen,offset AC_msg1,AC_DataLen

    push offset AC_poststr2
    lea eax,AC_querylen
    push eax
    push offset AC_poststr1
    push 2
    lea eax,AC_Header
    push eax
    call ConcatStrings
    test eax,eax
    jne @F
    mov ebx,4
    jmp AC_CaptchaErr
  @@:


    mov ebx,FUNC(lstrlen,addr AC_Header)
    push ebx
    invoke send,AC_iSock,addr AC_Header,ebx,0
    pop ebx
    cmp eax,ebx
    je @F
    mov ebx,5
    jmp AC_CaptchaErr
  @@:

    invoke send,AC_iSock,addr AC_Data1,AC_Data1Len,0
    cmp eax,AC_Data1Len
    je @F
    mov ebx,5
    jmp AC_CaptchaErr
  @@:


    invoke send,AC_iSock,AC_imagePtr,AC_imageSize,0
    cmp eax,AC_imageSize
    je @F
    mov ebx,5
    jmp AC_CaptchaErr
  @@:


    invoke send,AC_iSock,offset AC_content10,AC_content10len,0
    cmp eax,AC_content10len
    je @F
    mov ebx,5
    jmp AC_CaptchaErr
  @@:

    mov edi,AC_mem

    AC_sread:
      invoke recv,AC_iSock,edi,256,0

      cmp eax,-1
      jne @F
      mov ebx,6
      jmp AC_CaptchaErr
    @@:

      add edi,eax

      mov edx,edi
      sub edx,AC_mem
      cmp edx,AC_BUFFER_SIZE-257
      jb @F
      mov ebx,7
      jmp AC_CaptchaErr
    @@:

      cmp eax,0
    jne AC_sread

    mov byte ptr [edi],0

    invoke closesocket,AC_iSock
    mov AC_bConnected,0






    mov edx,istring(50,AC_mem,"ERROR_KEY_DOES_NOT_EXIST")
    test edx,edx
    je @F
    mov ebx,11
    jmp AC_CaptchaErr
  @@:

    mov edx,istring(50,AC_mem,"ERROR_WRONG_USER_KEY")
    test edx,edx
    je @F
    mov ebx,11
    jmp AC_CaptchaErr
  @@:

    mov edx,istring(50,AC_mem,"ERROR_NO_SLOT_AVAILABLE")
    test edx,edx
    je @F
    mov ebx,12
    jmp AC_CaptchaErr
  @@:

    mov edx,istring(50,AC_mem,"ERROR_ZERO_BALANCE")
    test edx,edx
    je @F
    mov ebx,13
    jmp AC_CaptchaErr
  @@:


    mov edx,istring(100,AC_mem,offset AC_substr1)
    test edx,edx
    jne @F
    mov ebx,20
    jmp AC_CaptchaErr
  @@:



    add edx,AC_mem
    add edx,2

    push edx
    invoke lstrlen,edx
    pop edx

    cmp eax,29
    jbe @F
    mov ebx,20
    jmp AC_CaptchaErr
  @@:

    invoke lstrcpy,AC_cID,edx

    mov eax,AC_cID
    xor ebx,ebx
ret
    AC_CaptchaErr:
      push ebx

      cmp AC_bConnected,0
      je @F
      invoke closesocket,AC_iSock
    @@:

      pop ebx
      xor eax,eax
ret
AntiCaptcha ENDP




;:
;push ptr apikey
;push ____ID_
;push answer ptr
;
; 
AntiCaptchaAnswer PROC, ACA_answer:DWORD, ACA_cID:DWORD, ACA_apikey:DWORD
    ACA_BUFFER_SIZE equ 2048

    LOCAL ACA_bConnected:BYTE
    LOCAL ACA_iSock:DWORD
    LOCAL ACA_DataLen:DWORD
    LOCAL ACA_Data [ACA_BUFFER_SIZE] :BYTE
    LOCAL ACA_mem :DWORD
    LOCAL ACA_querylen [10] :BYTE



  .data
    ACA_query1 db "GET /res.php?key=",0
    ACA_query2 db "&action=get&id=",0
    ACA_query3 db " HTTP/1.0",13,10, \
                  "Host: www.anti-captcha.com",13,10, \
                  "Connection: keep-alive",13,10,"Keep-alive: 300",13,10,"Content-Length: 0",13,10,13,10,0



  .code
    mov ACA_bConnected,0

    lea eax,ACA_Data
    mov ACA_mem,eax

    invoke socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
    CMP EAX,INVALID_SOCKET
    jne @F
    mov ebx,1
    jmp ACA_CaptchaErr
  @@:

    mov ACA_iSock,eax

    invoke connect,ACA_iSock,offset AC_SocketAddress,sizeof AC_SocketAddress
    test eax,eax
    je @F
    mov ebx,2
    jmp ACA_CaptchaErr
  @@:

    mov ACA_bConnected,1


    push offset ACA_query3
    push ACA_cID
    push offset ACA_query2
    push ACA_apikey
    push offset ACA_query1
    push 4
    lea eax,ACA_Data
    push eax

    call ConcatStrings
    test eax,eax
    jne @F
    mov ebx,4
    jmp ACA_CaptchaErr
  @@:



    mov ebx,FUNC(lstrlen,addr ACA_Data)
    push ebx
    invoke send,ACA_iSock,addr ACA_Data,ebx,0
    pop ebx
    cmp eax,ebx
    je @F
    mov ebx,5
    jmp ACA_CaptchaErr
  @@:

    mov edi,ACA_mem

    ACA_sread:
      invoke recv,ACA_iSock,edi,256,0

      cmp eax,-1
      jne @F
      mov ebx,6
      jmp ACA_CaptchaErr
    @@:

      add edi,eax

      mov edx,edi
      sub edx,ACA_mem
      cmp edx,ACA_BUFFER_SIZE-257
      jb @F
      mov ebx,7
      jmp ACA_CaptchaErr
    @@:

      cmp eax,0
    jne ACA_sread

    mov byte ptr [edi],0

    invoke closesocket,ACA_iSock
    mov ACA_bConnected,0



    mov edx,istring(50,ACA_mem,"CAPCHA_NOT_READY")
    test edx,edx
    je @F
    mov ebx,10
    jmp ACA_CaptchaErr
  @@:


    mov edx,istring(50,ACA_mem,"ERROR_KEY_DOES_NOT_EXIST")
    test edx,edx
    je @F
    mov ebx,11
    jmp ACA_CaptchaErr
  @@:

    mov edx,istring(50,ACA_mem,"ERROR_WRONG_USER_KEY")
    test edx,edx
    je @F
    mov ebx,11
    jmp ACA_CaptchaErr
  @@:

    mov edx,istring(50,ACA_mem,"ERROR_ZERO_BALANCE")
    test edx,edx
    je @F
    mov ebx,13
    jmp ACA_CaptchaErr
  @@:

    mov edx,istring(50,ACA_mem,"ERROR_NO_SUCH_CAPCHA_ID")
    test edx,edx
    je @F
    mov ebx,14
    jmp ACA_CaptchaErr
  @@:




    mov edx,istring(50,ACA_mem,offset AC_substr1)
    test edx,edx
    jne @F
    mov ebx,20
    jmp ACA_CaptchaErr
  @@:



    add edx,ACA_mem
    add edx,2

    push edx
    invoke lstrlen,edx
    pop edx

    cmp eax,29
    jbe @F
    mov ebx,20
    jmp ACA_CaptchaErr
  @@:


    invoke lstrcpy,ACA_answer,edx

    mov eax,ACA_answer
    xor ebx,ebx
ret
    ACA_CaptchaErr:
      push ebx

      cmp ACA_bConnected,0
      je @F
      invoke closesocket,ACA_iSock
    @@:

      pop ebx
      xor eax,eax
ret
AntiCaptchaAnswer ENDP









AntiCaptchaInit PROC
  .data
    AC_anticaptchaURL db "anti-captcha.com",0
  .code
    invoke gethostbyname,offset AC_anticaptchaURL
    test eax,eax
    jne @F
    mov eax,2
    ret
  @@:

    mov eax,[eax+12]
    mov eax,[eax]
    mov eax,[eax]

    MOV AC_SocketAddress.sin_addr,EAX

    invoke htons,80
    mov AC_SocketAddress.sin_port,AX

    MOV AC_SocketAddress.sin_family,AF_INET
    xor eax,eax
ret
AntiCaptchaInit ENDP

end start